library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_textio.all;
library std;
use std.textio.all;

entity full_adder_tb is
end entity;

architecture a of full_adder_tb is
   component full_adder is
      port (
         a, b, cin: in std_logic;
         s, cout: out std_logic
      );
   end component;
signal a: unsigned(2 downto 0);
signal o: unsigned(1 downto 0);
begin

uut: full_adder port map (
        a => a(0),
        b => a(1),
        cin => a(2),
        s => o(0),
        cout => o(1)
     );

   test: process
   file outfile: text;
   variable fstatus: file_open_status;
   variable buf: line;
   begin
      file_open(fstatus,outfile,"myfile.txt",write_mode);--open the file for writing
      write(buf, string'("Simulation of full adder"));
      writeline(outfile,buf); 
      for i in 0 to 7 loop
         a <= to_unsigned(i,3);
         wait for 20 ns;
         write(buf, std_logic_vector(a));
         write(buf, string'(" --> "));
         write(buf, to_integer(o));
         writeline(outfile,buf);
      end loop;
      file_close(outfile);
      wait;
   end process;

end architecture a;
